local version = "4.8"
local currentVersion
local available = false

storage.checkVersion = storage.checkVersion or 0

-- check max once per 12hours
if os.time() > storage.checkVersion + (12 * 60 * 60) then

    storage.checkVersion = os.time()
    
    HTTP.get("https://raw.githubusercontent.com/Vithrax/vBot/main/vBot/version.txt", function(data, err)
        if err then
          warn("[vBot updater]: Unable to check version:\n" .. err)
          return
        end

        currentVersion = data
        available = true
    end)

end

UI.Label("Bot".. version .." \n by pvp99")
UI.Button("Clique aqui no WhatsApp", function() g_platform.openUrl("https://chat.whatsapp.com/GQtMdjT4GrbJ27RZ6cdY8A") end)
UI.Separator()

schedule(5000, function()

    if not available then return end
    if currentVersion ~= version then
        
        UI.Separator()
        UI.Label("New vBot is available for download! v"..currentVersion)
        UI.Button("Go to vBot GitHub Page", function() g_platform.openUrl("https://github.com/Vithrax/vBot") end)
        UI.Separator()
        
    end

end)

lblInfo= UI.Label("-- >>PARTY<< --")

lblInfo:setColor("green")

UI.Separator()

local infoTime = 0
local talkTime = 0
local maxLevel = 0
local minLevel = 0
local justForInfo = true
local canSeeInfo = true
local partyMembersCount = 0

local partyLeaderHuntWidget = macro(1000, "Auto Party PVP99", function()
  if not player:isPartyLeader() then
    justForInfo = true
    partyMembersCount = 0
    return
  end
  if justForInfo and canSeeInfo then
    sayChannel(getChannelId("party"), "!party info")
    return
  end
  if talkTime > 0 then
    talkTime = talkTime - 1
  end
  if player:getShield() == 10 then
    infoTime = infoTime + 1
    if infoTime >= 20 then
      sayChannel(getChannelId("party"), "!party info")
      infoTime = 0
    end
  else
    infoTime = 0
  end
end)

addLabel("maxLevel", "Level Maximo da Party:")
addTextEdit("maxLevel", storage.maxLevel or "", function(widget, text)
  if tonumber(text) then
    maxLevel = tonumber(text)
  else
    sayChannel(getChannelId("party"), "!party info")
  end
  storage.maxLevel = tonumber(text)
end)

addLabel("minLevel", "Level Minino da Party:")
addTextEdit("minLevel", storage.minLevel or "", function(widget, text)
  if tonumber(text) then
    minLevel = tonumber(text)
  else
    sayChannel(getChannelId("party"), "!party info")
  end
  storage.minLevel = tonumber(text)
end)

onTalk(function(name, level, mode, text, channelId, pos)
  if partyLeaderHuntWidget:isOn() then
    if name == player:getName() then return end
    if text:lower():find("pt") or (text:lower():find("party") and not text:lower():find("!party")) then
      for _, spec in ipairs(getSpectators()) do
        if spec:getName() == name then
          if spec:isPartyMember() then return end
          if spec:getShield() == 2 then
            g_game.talkPrivate(5, name, name .. ", ja envitei voce caralho")
            return
          end
          if level > maxLevel or level < minLevel then
            g_game.talkPrivate(5, name, name .. ", o nivel minimo e " .. minLevel .. " e o maximo e " .. maxLevel)
            return
          end
          if partyMembersCount >= 40 then
            g_game.talkPrivate(5, name, name .. ", a party ja conta com maximo de 40 jogadores com experiencia compartilhada  .")
            return
          end
          g_game.partyInvite(spec:getId())
        end
      end
    end
  end
end)

onLoginAdvice(function(text)
  if partyLeaderHuntWidget:isOn() then
    local explode1 = string.explode(text, "*")
    local explode2 = string.explode(explode1[8], ":")[2]
    if not storage.maxLevel then
      maxLevel = math.ceil(tonumber(string.explode(explode1[4], ":")[2])*3/2)
    else
      maxLevel = storage.maxLevel
    end
    if not storage.minLevel then
      minLevel = math.ceil(tonumber(string.explode(explode1[3], ":")[2])*2/3)
    else
      minLevel = storage.minLevel
    end
    partyMembersCount = tonumber(string.explode(explode1[2], ":")[2])
    if justForInfo then
      justForInfo = false
      return
    end
    if explode2:find(",") then
      local names = string.explode(explode2, ",")
      for i = 1, #names do
        canSeeInfo = false
        schedule(1000 * i, function()
          if i == #names then
            canSeeInfo = true
          end
          sayChannel(getChannelId("party"), "!party kick," .. names[i])
        end)
      end
    elseif explode2 ~= "" then
      schedule(1000, function() sayChannel(getChannelId("party"), "!party kick," .. explode2) end)
    end
  end
end)

onCreatureAppear(function(creature)
  if partyLeaderHuntWidget:isOn() then
    if not creature:isPlayer() then return end
    if creature:isLocalPlayer() then return end
    if creature:getShield() == 2 then return end
    if creature:isPartyMember() then return end
    if talkTime == 0 and partyMembersCount < 40 then
      say("se voce quiser entrar na party fale 'pt'para que eu possa envita-lo")
      talkTime = 15
    end
  end
end)

onTextMessage(function(mode, text)
  if partyLeaderHuntWidget:isOn() then
    if text:lower():find("voce agora e o lider da party.") or text:lower():find("um boi entrou na party.") or (text:lower():find("um gay saiu da party.") and canSeeInfo) then
      justForInfo = true
    end
  end
end)

lblInfo= UI.Label("-- >>KNIGHT<< --")

lblInfo:setColor("green")

UI.Separator()

 ---------------------------------- Macro EK Rotação --------------------------------------------------------------------

local pvp = true
local Spells = {
    {name = "utito tempo", cast = true, amount = 3, distance = 1, safe = true, buffSpell = true, manaCost = 290, level = 60},
    {name = "exori gran", cast = true, amount = 3, distance = 1, manaCost = 340, level = 90},
    {name = "exori", cast = true, amount = 2, distance = 1, manaCost = 115, level = 35},
    {name = "exori min", cast = true, amount = 2, distance = 1, turning = true, manaCost = 200, level = 70},
    {name = "exori", cast = true, amount = 2, distance = 1, manaCost = 115, level = 35},
    {name = "exori gran ico", cast = true, amount = 1, distance = 1, safe = true, manaCost = 300, level = 110},
    {name = "exori ico", cast = true, amount = 1, distance = 1, safe = true, manaCost = 30, level = 16},
    {name = "exori hur", cast = true, amount = 1, distance = 5, safe = true, manaCost = 40, level = 28},
}



macro(500, "Exori", function()
    local isSafe = true;
    local target = g_game.getAttackingCreature()
    local direct
    local whitelistMonsters = {"Emberwing", "Skullfrost", "Groovebeast", "Thundergiant"}

if not g_game.isAttacking() then
    return
end

if player:getPosition().z == target:getPosition().z then
    if  player:getPosition().x > target:getPosition().x then direct = 3 -- west
    elseif  player:getPosition().x < target:getPosition().x then direct = 1 -- east
    elseif player:getPosition().y > target:getPosition().y then direct = 0 -- north
    elseif  player:getPosition().y < target:getPosition().y then direct = 2 -- south
    end
end

for _, spell in ipairs(Spells) do
    local specAmount = 0
    for i,mob in ipairs(getSpectators()) do
        if (getDistanceBetween(player:getPosition(), mob:getPosition())  <= spell.distance and mob:isMonster())  then
            if table.find(whitelistMonsters, mob:getName()) then
                specAmount = specAmount
            else
                specAmount = specAmount + 1
            end
        end
        if (mob:isPlayer() and player:getName() ~= mob:getName()) then
            isSafe = false;
        end
    end

    if (spell.cast) and (specAmount >= spell.amount) and (mana() >= spell.manaCost) and (lvl() >= spell.level) then
        if not spell.buffSpell or not hasPartyBuff() then
            if pvp then
                if isSafe then
                    if player:getDirection() ~= direct and (getDistanceBetween(player:getPosition(), target:getPosition())  <= spell.distance) and spell.turning then
                        turn(direct) 
                    end
                    say(spell.name)
             elseif not isSafe and spell.safe then
                    say(spell.name)        
                end
            else
                if player:getDirection() ~= direct and (getDistanceBetween(player:getPosition(), target:getPosition())  <= spell.distance) and spell.turning then
                    turn(direct) 
                end
                say(spell.name)
            end
        end
    end
end

end)

local rainbowOutfitTime = 1

rainbowOutfit = macro(rainbowOutfitTime, "Outfit", function ()
  rainbowOutfit()
end)

function rainbowOutfit()
    local randomColor = math.random(1,132)
    local pOutfit = player:getOutfit()
    local rainbowOutfit = { type = pOutfit.type, head = math.random(1,132), body = math.random(1,132), legs = math.random(1,132), feet = math.random(1,132), addons = pOutfit.addons}
    setOutfit(rainbowOutfit)
  return true
end

local ssa = macro(190, "Ssa e Mig", function()
local amulet = 3081
local might = 3048
if getNeck() == nill or getNeck():getId() ~= amulet then
g_game.equipItemId(amulet)
delay(30)
end
if getFinger() == nill or getFinger():getId() ~= might then
g_game.equipItemId(might)
delay(30)
end
end)

macro(40, "Dancing Afk", function()
turn(math.random(0, 3))
end)

macro(250, "Montar Sempre", function()
   local player = g_game.getLocalPlayer()
  if player then 
    player:mount()
  end
end)

macro(300, "Ant Paralize Tempo Hur", nil, function()
if isParalyzed() or not hasHaste() then
say("utani tempo hur")
end
end)

lblInfo= UI.Label("-- >>ATALHO<< --")

lblInfo:setColor("green")

UI.Separator()

macro(1, "Pausar BOT", function(killbot)
if TargetBot.isOn() or CaveBot.isOn() then
 TargetBot.setOff()
 CaveBot.setOff()
 killbot.setOff()
 else
 TargetBot.setOn()
 CaveBot.setOn()
 killbot.setOff()
 end
end)

macro(1 , "Push Items", function()
    local item = nil
    for _, tile in pairs(g_map.getTiles(posz())) do
        if distanceFromPlayer(tile:getPosition()) == 1 and #tile:getItems() ~= 0 and not tile:getTopUseThing():isNotMoveable() then
            item = tile:getTopUseThing()
            if item:isPickupable() then
                g_game.move(item, {x=65535, y=3, z=0}, item:getCount())
            end
            return
        end
    end
end)

macro(1000, "Auto Fish", function()
  for _, tile in ipairs(g_map.getTiles(posz())) do
    if table.contains({4596, 4597, 4598, 4599, 4600, 4601, 4602, 4603, 4614, 4615, 4616, 4617, 4618, 4619, 4620, 4621, 4622, 4623, 4624, 4625, 4665, 4666, 4820, 4821, 4822, 4823, 4824, 4825,4608, 4609, 4610, 4611, 4612, 4613, 7236, 4614, 4615, 4616, 4617, 4618, 4619}, tile:getTopUseThing():getId()) and getDistanceBetween(pos(), tile:getPosition()) <= 4 then
      useWith(3483, tile:getTopUseThing())
    end
  end
end)

local reUseToggle = macro(1000, "Click Magebot", "", function() end)
local excluded = {268, 237, 238, 23373, 266, 236, 239, 7643, 23375, 7642, 23374, 5908, 5942, storage.shovel, storage.rope, storage.machete} 

onUseWith(function(pos, itemId, target, subType)
  if reUseToggle.isOn() and not table.find(excluded, itemId) then
    schedule(50, function()
      item = findItem(itemId)
      if item then
        modules.game_interface.startUseWith(item)
      end
    end)
  end
end)

local field = 2123 -- field ID
local destroyField = 3148 --item q destroi
macro(1 , "Apaga Fogo Baiak", function()
local tileArroundMe = getNearTiles(pos())
  for _, tile in ipairs(tileArroundMe) do
    if tile:getTopUseThing():getId() == field then
       useWith(destroyField, tile:getTopUseThing())
    end
  end
end)

local field = 2118 -- field ID
local destroyField = 3148 --item q destroi
macro(1 , "Apaga Fogo Aurera", function()
local tileArroundMe = getNearTiles(pos())
  for _, tile in ipairs(tileArroundMe) do
    if tile:getTopUseThing():getId() == field then
       useWith(destroyField, tile:getTopUseThing())
    end
  end
end)

local panelName = "antiPushPanel"
local ui = g_ui.createWidget("ItemsPanel", panel)
ui:setId(panelName)

if not storage[panelName] then storage[panelName] = {} end

ui.title:setText("Anti Push")
ui.title:setOn(storage[panelName].enabled)
ui.title.onClick = function(widget)
    storage[panelName].enabled = not storage[panelName].enabled
    widget:setOn(storage[panelName].enabled)
end

if type(storage[panelName].items) ~= 'table' then
    storage[panelName].items = {3031, 0, 0, 0, 0}
end

for i = 1, 5 do
    ui.items:getChildByIndex(i).onItemChange =
        function(widget) storage[panelName].items[i] = widget:getItemId() end
    ui.items:getChildByIndex(i):setItemId(storage[panelName].items[i])
end

macro(100, function()
    if not storage[panelName].enabled then return end
    local tile = g_map.getTile(player:getPosition())
    if not tile then return end
    local topItem = tile:getTopUseThing()
    if topItem and topItem:isStackable() then
        topItem = topItem:getId()
    else
        topItem = 0
    end
    local candidates = {}
    for i, item in pairs(storage[panelName].items) do
        if item >= 100 and item ~= topItem and findItem(item) then
            table.insert(candidates, item)
        end
    end
    if #candidates == 0 then return end
    if type(storage[panelName].lastItem) ~= 'number' or
        storage[panelName].lastItem > #candidates then
        storage[panelName].lastItem = 1
    end
    local item = findItem(candidates[storage[panelName].lastItem])
    g_game.move(item, player:getPosition(), 1)
    storage[panelName].lastItem = storage[panelName].lastItem + 1
end)

if not storage.doorIds then
    storage.doorIds = { 5129, 5102, 5111, 5120, 11246 }
end

local moveTime = 2000     -- Wait time between Move, 2000 milliseconds = 2 seconds
local moveDist = 1        -- How far to Walk
local useTime = 2000     -- Wait time between Use, 2000 milliseconds = 2 seconds
local useDistance = 2     -- How far to Use

local function properTable(t)
    local r = {}
    for _, entry in pairs(t) do
        table.insert(r, entry.id)
    end
    return r
end

UI.Separator()
UI.Label("Door IDs")

local doorContainer = UI.Container(function(widget, items)
    storage.doorIds = items
    doorId = properTable(storage.doorIds)
end, true)

doorContainer:setHeight(35)
doorContainer:setItems(storage.doorIds)
doorId = properTable(storage.doorIds)

clickDoor = macro(1000, "Use Doors", function()
    for i, tile in ipairs(g_map.getTiles(posz())) do
        local item = tile:getTopUseThing()
        if item and table.find(doorId, item:getId()) then
            local tPos = tile:getPosition()
            local distance = getDistanceBetween(pos(), tPos)
            if (distance <= useDistance) then
                use(item)
                return delay(useTime)
            end

            if (distance <= moveDist and distance > useDistance) then
                if findPath(pos(), tPos, moveDist, { ignoreNonPathable = true, precision = 1 }) then
                    return delay(waitTime)
                end
            end
        end
    end
end)